// -*- c++ -*-
//  Generated by gtkmmproc from ../../gtkextra--/sheet.gen_h -- DO NOT MODIFY!
#ifndef _GTKEXTRAMM_SHEET_H
#define _GTKEXTRAMM_SHEET_H

// -*- C++ -*-

/* sheet.gen_h
 *
 * Copyright (C) 2000 GtkExtra-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/container.h>
#include <gtk--/button.h> //For button_attach().
//#include <gtk--/scrollbar.h>
#include <gtkextra/gtksheet.h>
#include "gtkextramm_marshal.h"

using namespace Gtk;

namespace GtkExtra {
class Sheet;
class Sheet_Class;
}
namespace Gtk { GtkExtra::Sheet *wrap (GtkSheet *o); }
namespace GtkExtra
{

class Adjustment;

//: GtkExtra GtkSheet widget.
//- A grid widget.
//- Allows user editing of cells.
//- Allows adding/removing of rows and columns at runtime.
//- Rows and Columns are zero-indexed. The title row and column are -1.

class Sheet : public Container
{

public:
  typedef Sheet          CppObjectType;
  typedef Sheet_Class    CppClassType;
  typedef GtkSheet           BaseObjectType;
  typedef GtkSheetClass      BaseClassType;

private:
  friend class Sheet_Class;
  static CppClassType sheet_class;

  Sheet(const Sheet&);
  Sheet& operator=(const Sheet&); // not implemented

protected:
  void   initialize_class();
  explicit Sheet(GtkSheet *castitem);

public:
  static GtkType get_type();
  GtkSheet* gtkobj()             { return (GtkSheet*)(gtkobject); }
  const GtkSheet* gtkobj() const { return (GtkSheet*)(gtkobject); }
  static bool isA(Gtk::Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Sheet();

private:

public:

  //: Use bBrowser = true to create a browse-only sheet.
  Sheet(guint rows, guint columns, const nstring& title, bool bBrowser = false);

  //: This constructor can be used to change the widget used in the cell.
  //- In the sheet example, Gtk::Combo::get_type() doesn't seem to work, but gtk_combo_get_type does.
  Sheet(guint rows, guint columns, const nstring& title, GtkType entry_type);



  // get adjustments of sheet
  //RAP_MEMBER(value, hadjustment, hadjustment,Gtk::Adjustment*, GtkAdjustment*);
  //RAP_MEMBER(value, vadjustment, vadjustment,Gtk::Adjustment*, GtkAdjustment*);

  //: set horizontal adjustment


  void set_hadjustment(Gtk::Adjustment* adjustment);

  //: set vertical adjustment


  void set_vadjustment(Gtk::Adjustment* adjustment);

  //: get horizontal adjustment


  Gtk::Adjustment* get_hadjustment();

  //: get vertical adjustment


  Gtk::Adjustment* get_vadjustment();

  //: Change the widget used in the cell.
  //- In the sheet example, Gtk::Combo::get_type() doesn't seem to work, but gtk_combo_get_type does.


  void change_entry(GtkType type);

  //: Returns sheet's entry widget


  Gtk::Widget* get_entry();

  //:  Returns sheet->state


  gint get_state();



  void get_visible_range(GtkSheetRange& refRange);



  void set_selection_mode(gint mode);

  //:  Set sheet title


  void set_title(const nstring& title);

  //:  Set border style
  //Declared but not implemented in GtkExtra:
  //void gtk_sheet_set_border(GtkSheet*, GtkShadowType),


  //: Freezes all visual updates of the sheet.
  //- Then thaw the sheet after you have made a number of changes.
  //- The updates will occur in a more efficent way than if you made them on an unfrozen sheet.


  void freeze();



  void thaw();




  void set_background(GdkColor* bg_color);




  void set_grid(GdkColor* grid_color);




  void show_grid(bool show);



  bool grid_visible();

  //: Set column title


  void set_column_title(gint column,const nstring& title);

  //: Set row title


  void set_row_title(gint row,const nstring& title);

  //: Set button label


  void row_button_add_label(gint row,const nstring& label);



  void column_button_add_label(gint column,const nstring& label);



  void row_button_justify(gint row,GtkJustification justification);



  void column_button_justify(gint column,GtkJustification justification);

  //: Scroll the viewing area of the sheet to the given column and row.
  //- row_align and col_align are between 0-1 representing the location the row should appear on the screen.
  //- 0.0 is top or left, 1.0 is bottom or right.
  //- If row or column is negative then there is no change.


  void moveto(gint row,gint column,gfloat row_align,gfloat col_align);

  //: Resize row titles


  void set_row_titles_width(guint width);

  //: Resize column titles


  void set_column_titles_height(guint height);

  //: Show column titles


  void show_column_titles();

  //: Show row titles


  void show_row_titles();

  //: Hide column titles


  void hide_column_titles();

  //: Hide row titles


  void hide_row_titles();

  //: Set column button sensitivity.
  //- If sensitivity is true it can be toggled.
  //- Otherwise it acts as a title.


  void column_set_sensitivity(gint column,bool sensitive);

  //: Set sensitivity for all column buttons


  void set_sensitivity(bool sensitive);

  //: Set row button sensitivity.
  //- If sensitivity is true it can be toggled.
  //- Otherwise it acts as a title.


  void row_set_sensitivity(gint row,bool sensitive);

  //: Set sensitivity for all row buttons


  void rows_set_sensitivity(bool sensitive);

  //: set column visibility.
  //- The default value is true.
  //- If false, the column is hidden.


  void column_set_visiblity(gint column,bool visible);


  void column_label_set_visiblity(gint column,bool visible);


  void columns_labels_set_visiblity(bool visible);

  //: Set row visibility.
  //- The default value is true.
  //- If false, the row is hidden.


  void row_set_visibility(gint row,bool visible);


  void column_row_set_visiblity(gint row,bool visible);


  void rows_labels_set_visiblity(bool visible);

  //: Select the row.
  //- The range is then highlighted, and the bounds are stored in sheet->range
  //- User emittable function


  void cause_select_row(gint row);

  //: Select the column.
  //- The range is then highlighted, and the bounds are stored in sheet->range
  //- User emittable function


  void cause_select_column(gint column);

  //: Save selected range to "clipboard"
  //- User emittable function


  void cause_clip_range(const GtkSheetRange& range);

  //: Free clipboard


  void unclip_range();

  //: Highlight the selected range
  //- Stores bounds in sheet->range
  //- User emittable function


  void cause_select_range(const GtkSheetRange& range);



  void unselect_range();

  //: Set active cell where the entry will be displayed
  //- returns false if current cell can't be deactivated or requested cell can't be activated.


  bool set_active_cell(gint row,gint column);

  //: Get active cell
  //- Returns -1, -1 if there is no active cell.


  void get_active_cell(gint& row,gint& column);

  //: Set cell contents.
  //- User emittable function


  void cause_set_cell(gint row,gint col,GtkJustification justification,const nstring& text);

  //: Set cell contents
  //- This override allows a default justification.
  void cause_set_cell(gint row, gint col, const nstring &text, GtkJustification justification = GTK_JUSTIFY_LEFT);



  void set_cell_text(gint row,gint col,const nstring& text);

  //: Get cell contents


  nstring get_cell_text(gint row,gint col);

  //: Clear cell contents


  void cell_clear(gint row,gint col);

  //: Clear cell contents and remove links


  void cell_delete(gint row,gint col);

  //: Clear range contents.
  //- Use range_clear() without arguments to clear whole sheet.


  void range_clear(const GtkSheetRange& range);

  //: Clear whole sheet.
  void range_clear();

  ///: Clear range contents and remove links


  void range_delete(const GtkSheetRange& range);

  //: Get cell state
  //- GTK_STATE_NORMAL, GTK_STATE_SELECTED


  GtkStateType cell_get_state(gint row,gint col);

  //: Handles cell links


  void link_cell(gint row,gint col,gpointer link);



  gpointer get_link(gint row,gint col);



  void remove_link(gint row,gint col);

  //: Get row and column corresponding to the given position in the screen


  bool get_pixel_info(gint x,gint y,gint& row,gint& column);

  //: Get area of a given cell


  bool get_cell_area(gint row,gint column,Gdk_Rectangle& area);

  //: Set column width


  void set_column_width(guint column,guint width);

  //: Set row height


  void set_row_height(gint row,guint height);

  //: Append columns to the end of the sheet


  void add_column(guint ncols);

  //: Append rows to the end of the sheet


  void add_row(guint nrows);

  //: Insert rows before the given row, and pull right


  void insert_rows(guint row,guint nrows);

  //: Insert columns before the given col, and pull down


  void insert_columns(guint col,guint ncols);

  //: Delete nrows rows starting in row


  void delete_rows(guint row,guint nrows);

  //: Delete ncols columns starting in col


  void delete_columns(guint col,guint ncols);

  //: Set background color of the given range


  void range_set_background(const GtkSheetRange& range,const Gdk_Color& color);

  //: Set foreground color (text color) of the given range


  void range_set_foreground(const GtkSheetRange& range,const Gdk_Color& color);

  //: Set text justification (GTK_JUSTIFY_LEFT, RIGHT, CENTER) of the given range.
  //- The default value is GTK_JUSTIFY_LEFT.
  //- If autoformat is on, the default justification for numbers is GTK_JUSTIFY_RIGHT


  void range_set_justification(const GtkSheetRange& range,GtkJustification justification);



  void column_set_justification(gint column,GtkJustification justification);

  //: Whether cell contents in the given range can be edited.


  void range_set_editable(const GtkSheetRange& range,bool editable);

  //: Whether cell contents in the given range are visible.


  void range_set_visible(const GtkSheetRange& range,bool visible);

  //: Set cell border style in the given range.
  //- mask: CELL_LEFT_BORDER, CELL_RIGHT_BORDER, CELL_TOP_BORDER, CELL_BOTTOM_BORDER
  //- width: width of the border line in pixels.
  //- line_style: Line style for the border line.


  void range_set_border(const GtkSheetRange& range,gint mask,guint width,gint line_style);

  //: Set border color for the given range


  void range_set_border_color(const GtkSheetRange& range,const Gdk_Color& color);

  //: Set font for the given range


  void range_set_font(const GtkSheetRange& range,const Gdk_Font& font);

  //: Get cell attributes of the given cell
  //- Result indicates whether the cell is currently allocated.


  bool get_attributes(gint row,gint col,GtkSheetCellAttr& attributes);



  GtkSheetChild* put(Gtk::Widget* widget,gint x,gint y);



  void attach(Gtk::Widget* widget,gint row,gint col,gfloat x_align,gfloat y_align);



  void move_child(Gtk::Widget* widget,gint x,gint y);



  GtkSheetChild* get_child_at(gint row,gint col);

  //: Attach a widget to the title button.
  //- row and/or col should be -1, because this only seems to work with the title cells.


  void button_attach(Gtk::Widget& widget,gint row,gint col,gfloat x_align,gfloat y_align);



  GtkSheetCell get_active_cell() const;
  //: Get count of columns.


  guint get_columns_count();

  //: Get count of rows.


  guint get_rows_count();


  GtkSheetRange get_selected_range() const;
  //: Get information about the column.
  //- column index is zero-indexed.
  //- bool indicates success.
  bool get_column(gint index, GtkSheetColumn& refColumn);
  //RAP_MEMBER(value, columns, column, GtkSheetColumn*, GtkSheetColumn*);

  //: Get information about the row.
  //- row index is zero-indexed.
  //- bool indicates success.
  bool get_row(gint index, GtkSheetRow& refRow);
  //RAP_MEMBER(value, rows, row, GtkSheetRow*, GtkSheetRow*);

  //Invented functions to replace GtkExtra flag macros:
  //I have only added these functions when I see the macros used in testgtksheet,
  //because I do not want to encourage this kind of thing.
  void set_auto_scroll(bool bVal = true);
  void set_auto_resize(bool bVal = true);
  bool get_in_clip();


 // User emittable function: See cause_

 // User emittable function: See cause_
 // User emittable function: See cause_
 // User emittable function: See cause_

 // User emittable function: See cause_

    //,void set_scroll_adjustments(GtkSheet*, GtkAdjustment*, GtkAdjustment*));

public:

  union
    {
      CppObjectType * sheet_self;
      Gtk::ProxySignal1<void,gint,CppObjectType,BaseObjectType,0> select_row;
      Gtk::ProxySignal1<void,gint,CppObjectType,BaseObjectType,1> select_column;
      Gtk::ProxySignal1<void,GtkSheetRange*,CppObjectType,BaseObjectType,2> select_range;
      Gtk::ProxySignal1<void,GtkSheetRange*,CppObjectType,BaseObjectType,3> clip_range;
      Gtk::ProxySignal2<void,GtkSheetRange*,GtkSheetRange*,CppObjectType,BaseObjectType,4> resize_range;
      Gtk::ProxySignal2<void,GtkSheetRange*,GtkSheetRange*,CppObjectType,BaseObjectType,5> move_range;
      Gtk::ProxySignal4<gboolean,gint,gint,gint*,gint*,CppObjectType,BaseObjectType,6> traverse;
      Gtk::ProxySignal2<gboolean,gint,gint,CppObjectType,BaseObjectType,7> deactivate;
      Gtk::ProxySignal2<gboolean,gint,gint,CppObjectType,BaseObjectType,8> activate;
      Gtk::ProxySignal2<void,gint,gint,CppObjectType,BaseObjectType,9> set_cell;
      Gtk::ProxySignal2<void,gint,gint,CppObjectType,BaseObjectType,10> clear_cell;
      Gtk::ProxySignal2<void,gint,gint,CppObjectType,BaseObjectType,11> changed;
      Gtk::ProxySignal2<void,gint,guint,CppObjectType,BaseObjectType,12> new_column_width;
      Gtk::ProxySignal2<void,gint,guint,CppObjectType,BaseObjectType,13> new_row_height;
      Gtk::ProxySignal2<void,GtkAdjustment*,GtkAdjustment*,CppObjectType,BaseObjectType,14> set_scroll_adjustments;
    };

protected:
  // impl functions
    virtual void select_row_impl(gint p0);
    virtual void select_column_impl(gint p0);
    virtual void select_range_impl(GtkSheetRange* p0);
    virtual void clip_range_impl(GtkSheetRange* p0);
    virtual void resize_range_impl(GtkSheetRange* p0,GtkSheetRange* p1);
    virtual void move_range_impl(GtkSheetRange* p0,GtkSheetRange* p1);
    virtual gboolean traverse_impl(gint p0,gint p1,gint* p2,gint* p3);
    virtual gboolean deactivate_impl(gint p0,gint p1);
    virtual gboolean activate_impl(gint p0,gint p1);
    virtual void set_cell_impl(gint p0,gint p1);
    virtual void clear_cell_impl(gint p0,gint p1);
    virtual void changed_impl(gint p0,gint p1);
    virtual void new_column_width_impl(gint p0,guint p1);
    virtual void new_row_height_impl(gint p0,guint p1);
    virtual void set_scroll_adjustments_impl(GtkAdjustment* p0,GtkAdjustment* p1);

};

}

#endif
